
/*


int Get_AddToUtc_ToGetServer()
        
     = UTC + Get_AddToUtc_ToGetServer()

int Get_AddToUtc_ToGetLocal()
        
     = UTC + Get_AddToUtc_ToGetServer()
    
 (  ):

     = 
        ( - Get_AddToUtc_ToGetServer()) + 
        Get_AddToUtc_ToGetServer()
*/

#import "timeService.dll"

// ,    Utc 
//       
int timeService(
        string timeServerThere, //     -timestamp'
        int & utcToServer[],
        int & utcToLocal[]
        );
        
// ,       Unix TimeStamp 
// (  1970  - ..  ),   
int 
getLocalTime(
        datetime & time[]
        );
#import

string getTimeStamp(datetime t)
{
    string s = TimeToStr(t, TIME_DATE | TIME_MINUTES | TIME_SECONDS);
    return (s);
}

//        
//  - 
bool compare(datetime d1, datetime d2, int allowedThreshold)
{
    if(MathAbs(d1 - d2) <= allowedThreshold)
    {
        return (true);
    }
    
    return (false);
}

extern int Default_AddToUtc_ToGetServer = 7200;
extern int Default_AddToUtc_ToGetLocal  = 14400;

//    
//   
int AddToUtc_ToGetServer = 0;
int AddToUtc_ToGetLocal  = 0;

void Message(string source)
{
    string hUtcToServer = DoubleToStr(AddToUtc_ToGetServer / 3600.0, 1);
    string hUtcToLocal  = DoubleToStr(AddToUtc_ToGetLocal / 3600.0, 1);
    string str = source + " UtcToServer: " + hUtcToServer + ", UtcToLocal: " + hUtcToLocal;
    Alert("TIMEZONE: " + str);
}

bool FRESH = false;
bool FIRSTCALL = true;
    
//   
// (!)    -    
//  -   
void CalculateTimeZone()
{
    string source = "";

    for(;;)
    {
        datetime serverTime = TimeCurrent();
        string s = getTimeStamp(serverTime);

        //   
        int utcToServer[1]; utcToServer[0] = 0;
        int utcToLocal[1];  utcToLocal[0] = 0;
        timeService(s, utcToServer, utcToLocal);
        
        //     
        datetime localReal[1]; localReal[0] = 0;
        getLocalTime(localReal);

        //      
        datetime local = serverTime - utcToServer[0] + utcToLocal[0];
        string strLocalCalc = getTimeStamp(local);
        string strLocalReal = getTimeStamp(localReal[0]);
    
        if(compare(local, localReal[0], 3) == true)
        {
            //     ! 
            //  !
            FRESH = TRUE;
            source = "CALCULATED. FRESH.";
            break;
        }
        else
        {
            Print("--- Failure: Local time: calc: " + strLocalCalc + " vs real: " + strLocalReal);

            //   
            int readFile = FileOpen("timeZoneData.txt", FILE_READ | FILE_BIN);
            if(readFile != -1)
            {
                utcToServer[0] = FileReadInteger(readFile);
                utcToLocal[0] = FileReadInteger(readFile);
                FileClose(readFile);
                source = "RESTORED FROM FILE.";
            }
            else
            {
                utcToServer[0] = Default_AddToUtc_ToGetServer;
                utcToLocal[0] = Default_AddToUtc_ToGetLocal;
                source = "SORRY: USING DEFAULT VALUES";
            }
                        
            break;
        }
    }

    //  
    AddToUtc_ToGetServer = utcToServer[0];
    AddToUtc_ToGetLocal = utcToLocal[0];
    
    if(FRESH)
    {
        //   
        int saveFile = FileOpen("timeZoneData.txt", FILE_WRITE | FILE_BIN);
        FileWriteInteger(saveFile, AddToUtc_ToGetServer);
        FileWriteInteger(saveFile, AddToUtc_ToGetLocal);
        FileClose(saveFile);
    }
        
    //      
    Print("--- " + source + ": Local time: calc: " + strLocalCalc + " vs real: " + strLocalReal);
    Print("--- Server time is " + s);
    Print("--- " + source + ": Utc to Server +" + utcToServer[0] + " --- Utc to Local +" + utcToLocal[0]);

    if((FIRSTCALL == true) || (FRESH == true))
    {    
        Message(source);
    }
    FIRSTCALL = false;
}

int Get_AddToUtc_ToGetServer()
{
    if((AddToUtc_ToGetServer == 0) && (AddToUtc_ToGetLocal == 0))
    {
        CalculateTimeZone();
    }
    if(FRESH == false)
    {
        CalculateTimeZone();
    }
    
    return (AddToUtc_ToGetServer);
}

int Get_AddToUtc_ToGetLocal()
{
    if((AddToUtc_ToGetServer == 0) && (AddToUtc_ToGetLocal == 0))
    {
        CalculateTimeZone();
    }
    if(FRESH == false)
    {
        CalculateTimeZone();
    }
    
    return (AddToUtc_ToGetLocal);
}



